=== debian/changelog ===
dpuser (4.2+dfsg-1) unstable; urgency=medium

  * New upstream version 4.2+dfsg
  * Rediff patches
  * Push Standards-Version to 4.7.0. No changes needed
  * Update d/copyright and d/clean for generated files
  * New build dependency libdfitsio-dev

 -- Ole Streicher <olebole@debian.org>  Sat, 05 Oct 2024 15:50:12 +0200
