## dpuser 4.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -90,7 +90,7 @@
 if (NOT QT_PATH)
   if(WIN32)
     message("win32")
-    get_filename_component(QT_PATH "/Qt" ABSOLUTE)
+    get_filename_component(QT_PATH "/Qt/static" ABSOLUTE)
   elseif(APPLE)
     message("apple")
     get_filename_component(QT_PATH "/Users/ott/Qt/6.5.3/macos/lib/cmake/Qt6" ABSOLUTE)
@@ -142,8 +142,8 @@
 #@                  )
 
 # BISON & FLEX - uncomment if modifying the parsers
-#find_package(BISON 2.6)
-#find_package(FLEX 2.5)
+find_package(BISON 2.6)
+find_package(FLEX 2.6.4)
 
 # mpfit subdirectory
 IF(BISON_FOUND AND FLEX_FOUND)
@@ -195,7 +195,6 @@
    ${DPUSER_PATH}/python_dpuser.cpp
    ${DPUSER_PATH}/doc/helpmap.cpp
    ${DPUSER_PATH}/mpfit/mpfitAST.cpp
-   ${DPUSER_PATH}/parser/svn_revision.cpp
    )
 
 IF(BISON_FOUND AND FLEX_FOUND)
@@ -410,3 +409,5 @@
    set(app_icon_macos "${CMAKE_CURRENT_SOURCE_DIR}/resources/telescope.icns")
    set_source_files_properties(${app_icon_macos} PROPERTIES
            MACOSX_PACKAGE_LOCATION "Resources")
+   set_target_properties(QFitsView PROPERTIES
+      MACOSX_BUNDLE TRUE
