=== Makefile ===
--- 
+++ 
@@ -8,9 +8,8 @@
 #   make debug              (static, 32/64-bit autodetect)
 #   make debug_shared       WIN only (shared, 32/64-bit autodetect)
 #   make clean              to clean up the project
-#   make revision           creates the revision-string
 #   make dist               LINUX/MACOSX only to create a distribution as
-#                           tar.gz-file, calls automatically the revision-target
+#                           tar.gz-file
 #                           (do a checkout to a new location before, since all
 #                           .svn-folders will be deleted!)
 #
@@ -115,7 +114,6 @@
               dpuser.input.o \
               procedures.o \
               lex.yy.o \
-              svn_revision.o \
 							gdl_dpuser.o \
 							python_dpuser.o \
 							cpgplot.o \
@@ -135,12 +133,6 @@
    RM             = del
    SED_INPLACE    = ../bin/WIN/sed.exe -i
    
-   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
-   REV_NR := $(shell svnversion -c ..)
-   $(shell @echo $(REV_NR) > _bbb.txt)
-   REV_NR := $(shell sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://' _bbb.txt)
-   $(shell del _bbb.txt)
-
    ifndef $(ARCH)
    # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
       ARCH := $(shell wmic os get osarchitecture)
@@ -183,8 +175,6 @@
 				 
    LDFLAG      = -static-libgcc -static-libstdc++ -static -Wl,--enable-runtime-pseudo-reloc
 else
-   REV_NR := $(shell svnversion -c .. | sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://')
-
    ifeq ($(shell uname -m), x86_64)
       ARCH = 64
    else
@@ -302,10 +292,10 @@
 # sub targets
 
 ifeq ($(OS), WIN) # start WIN
-static: revision parsers
+static: parsers
 	$(MAKE) $(MULTIPROZGEIL) $(TARGET_WIN)
 else # end WIN, start LINUX & MACOSX
-static: doc/helpmap.cpp revision parsers
+static: doc/helpmap.cpp parsers
 	$(MAKE) $(MULTIPROZGEIL) $(TARGET_LINUX)
 endif # end LINUX & MACOSX
 
@@ -325,7 +315,7 @@
 parsers_qf:
 	$(MAKE) -C mpfit PLATFORM=$(OS)
 
-aux: revision parsers doc/helpmap.cpp
+aux: parsers doc/helpmap.cpp
 
 clean:
 	-$(RM) $(OBJECTS)
@@ -343,14 +333,30 @@
 
 FORCE:
 
-################################################################################
-# Updates the revision in parser/svn_revision.h
-revision:
-ifeq ($(OS), WIN)
-	echo #include "svn_revision.h" > parser/svn_revision.cpp
-	echo. >> parser/svn_revision.cpp
-	echo const char* GetRevString() { return "Rev. $(REV_NR)"; } >> parser/svn_revision.cpp
-else
-	@echo '#include "svn_revision.h"' > parser/svn_revision_new.cpp; \
-	echo '' >> parser/svn_revision_new.cpp; \
-	echo 'const char* GetRevString() { return "Rev. $(REV_NR)"; }' >> parser/svn_revision_new.cpp; \
+
+################################################################################
+# Creates a distribution
+ifeq ($(OS), WIN) # start WIN
+dist:
+	@echo "*************************************************************"
+	@echo "ERROR: Distribution can only be generated under LINUX or MAC!"
+	@echo "*************************************************************"
+else # end WIN, start LINUX & MACOSX
+dist: clean
+	cd ../QFitsView && make -i clean
+	find .. -type d -name ".svn" -exec rm -rf {} +
+	find .. -type d -name "obsolete" -exec rm -rf {} +
+	find .. -regextype posix-extended -regex '.*\.(a|lib|dll|exe)' -exec rm {} +
+	rm -rf ../include/*
+	rm -rf ../bin/*
+	rm -rf ../external/*z
+	tar cfvz ../../dpuser.tar.gz ../../$(TARDIR)
+endif # end LINUX & MACOSX
+
+################################################################################
+# Compile rules
+dpuser.o:              dpuser.cpp \
+                       dpuser.h \
+                       dpuser.yacchelper.h \
+                       dpuser.procs.h \
+                       procedures.h \
