=== mpfit/CMakeLists.txt ===
find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

BISON_TARGET(mpfity mpfit.y "${CMAKE_CURRENT_BINARY_DIR}/y.mpfit.c")
FLEX_TARGET(mpfitl mpfit.l "${CMAKE_CURRENT_BINARY_DIR}/lex.mpfit.c")
ADD_FLEX_BISON_DEPENDENCY(mpfitl mpfity)
