=== debian/changelog ===
dpuser (4.3+dfsg-1) unstable; urgency=medium

  * New upstream version 4.3+dfsg
  * Rediff patches
  * Replace virtual package libz-dev with zlib1g-dev
  * Push Standards-Version to 4.7.2, no changes needed

 -- Ole Streicher <olebole@debian.org>  Mon, 17 Mar 2025 13:27:46 +0100
