=== debian/control ===
--- 
+++ 
@@ -19,8 +19,8 @@
                libxpa-dev,
                qtbase5-dev,
                qtchooser,
-               libz-dev
-Standards-Version: 4.7.0
+               zlib1g-dev
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/dpuser
 Vcs-Git: https://salsa.debian.org/debian-astro-team/dpuser.git
 Homepage: https://www.mpe.mpg.de/~ott/dpuser/index.html
